###
### Rank Regression with Wilcoxon Weights
### Brent Johnson
### 9 Jan 2008
###
### y = n-by-1 response vector
### x = n-by-p matrix (assumed to be mean zero)
### binit = p-by-1 vector (from median regression)

rankbaj <- function(y,x,binit,MAXITER=100,TOL=1E-8) {
    xbar=apply(x,2,mean)
    x=apply(x,2,function(x){x-mean(x)})

	it <- 1
	absdiff <- 10
	bnew <- binit
	p <- length(binit)
	n <- length(y)
	xtx <- t(x) %*% x
	xtxi <- solve(xtx)
	while ((it<MAXITER) && (absdiff>TOL)) {
		bold <- bnew
		cat("b = ",bold,"\n")
		res <- y - x %*% bold
		wt <- (rank(res)/(n+1)) - 0.5
		S <- -1*(t(x) %*% wt)
		cat("S = ",round(S,4),"\n")
		tau <- wilcoxontau(res,p)
		#print(xtx/tau)
		bstep <- tau*(xtxi %*% S)
		cat("bstep = ",round(bstep,4),"\n")
		bnew <- bold - bstep
		it <- it + 1
		absdiff <- max(abs(bstep)) 
	}
	V <- (tau^2)*xtxi
	bhat <- as.vector(bnew)
	sehat <- sqrt(diag(V))
	list(b=bhat,se=sehat)
}
