###
### Test Rank Regression
###

CWD <- "/Users/brentjohnson/Documents/Teaching/WilcoxonRegression"
setwd(CWD)

library(quantreg)
source("RankBaj.R")
source("RankMM.R")

n <- 40
beta <- c(3,1.5,0,0,2,0,0,0)
p <- length(beta)
x <- matrix(rnorm(n*p),nrow=n,ncol=p)
y <- x %*% beta + rnorm(n)

tmp.df <- data.frame(y=y,x1=x[,1],x2=x[,2],x3=x[,3],x4=x[,4],x5=x[,5],x6=x[,6],x7=x[,7],x8=x[,8])
#m1 <- rq(y ~ -1 + x1 + x2,data=tmp.df) # no intercept
out.med <- rq(y ~ x1+x2+x3+x4+x5+x6+x7+x8,data=tmp.df)
b.med <- out.med$coef[2:(p+1)]

out.full <- rankbaj(y,x,b.med,MAXITER=20,TOL=1E-4)
b.full <- out.full$b

awt <- rep(1,p)
out.l <- rankmm(y,x,b.full,lam=0.1,awt=awt,MAXITER=20,TOL=1E-4)
b.l <- out.l$b

awt <- 1/abs(b.full)
out.al <- rankmm(y,x,b.full,lam=0.1,awt=awt,MAXITER=20,TOL=1E-4)
b.al <- out.al$b
